let {token} = window.customChatbotConfig
let {imageToggle} = window.customChatbotConfig
let {Popover} = window.customChatbotConfig
let {baseUrl} = window.customChatbotConfig
let {colorBg} = window.customChatbotConfig

  async function embedChatbot() {
    const link = document.createElement('link');
    link.rel = 'stylesheet';
    link.href = 'https://cdnjs.cloudflare.com/ajax/libs/font-awesome/6.0.0-beta3/css/all.min.css';
    document.head.appendChild(link);

    const style = document.createElement("style");
    document.head.appendChild(style);
    style.sheet.insertRule(
      `
      @keyframes move {
        0% { 
        opacity: 0.1;
        transform: translateY(50px); 
        }
        50%{
        opacity: 0.5;
        }
        100% { 
        opacity: 1;
        transform: translateY(0px); 
        }
      }
    `,
      0
    );
    style.sheet.insertRule(
      `
      @keyframes remove {
        0% { 
          opacity: 1;
          transform: translateY(0px); 
        }
        50% {
          opacity: 0.5;
        }
        100% { 
          opacity: 0.1;
          transform: translateY(50px); 
        }
      }
    `,
      1
    );
    style.sheet.insertRule(
    `
     @keyframes slideIn {
     0% {
        transform: translateY(300px);
        opacity: 0;
      }
      100% {
        transform: translateY(0px);
        opacity: 1;
      }
    }
    `,
    2
  );
  style.sheet.insertRule(
    `
     @keyframes slideIn2 {
     0% {
        transform: translateX(300px);
        opacity: 0;
      }
      100% {
        transform: translateX(0px);
        opacity: 1;
      }
    }
    `,
    3
  );
  style.sheet.insertRule(
    `
     @keyframes rotate {
     0% {
      transform: rotate(45deg) scale(0.8) ;
      }
      100% {
        transform: rotate(0deg) ,scale(1);
      }
    }
    `,
    4
  );
  style.sheet.insertRule(
    `
    @keyframes rotateClose {
     0% {
      transform: rotate(-45deg) scale(0.8) ;
      }
      100% {
        transform: rotate(0deg) ,scale(1);
      }
    }
    `,
    5
  );
      
    if (!document.getElementById("custom-chatbot-bubble-button")) {
      if(Popover){
        var popover = document.createElement("div");
        popover.id = 'custom-popover-id';
        popover.style.cssText = `
          position: relative;
          color: #425b76;
          font-family: Arial, Helvetica, sans-serif;
          font-size: 13px;
          position: fixed;
          bottom: 90px; 
          right: 16px;
          width: fit-content;
          padding: 5px;
          padding-bottom: 15px;
          min-width: 200px;
          max-width: 200px;
          max-height: 83px;
          border-radius: 8px;
          box-shadow: rgba(0, 0, 0, 0.2) 0px 1px 5px 0px; 
          background-color: #ffffff; 
          cursor: pointer; 
          z-index: 2147483640; 
          transition: all 0.5s ease-in-out 0s; 
          animation: slideIn  0.2s ease-in-out;
          transform: scale(1);
          display:flex;
          justify-content: center;
          `;
          const closeButtonContainer = document.createElement("div")
          closeButtonContainer.style.cssText = `
            position: absolute;
            z-index: 2147483640;
            top: 3px;
            right: 3px;
            width: 20px;
            height: 20px;
            padding: 5px;
            cursor: pointer;
            border-radius: 9999px;
          `
          const closeButton = document.createElement("i");
            closeButton.className = "fa fa-times";
            closeButton.style.cssText = `
              display: flex;
              justify-items: center;
              justify-content: center;
              color: #33475b;
              border: none;
              font-size: 18px;
              font-weight: bold;
              animation: slideIn2  0.2s ease-in-out forwards;
            `;
            closeButtonContainer.appendChild(closeButton)
          popover.appendChild(closeButtonContainer)

          closeButtonContainer.addEventListener('mouseover', ()=>{
            closeButtonContainer.style.background = '#f3f4f6'
          })
          closeButtonContainer.addEventListener('mouseout', ()=>{
            closeButtonContainer.style.background = 'none'
          })
          closeButtonContainer.addEventListener('click', ()=>{
            popover.style.display= 'none'
          })
         const valuepopover = document.createElement("span")
         valuepopover.innerHTML = `${Popover}`
         valuepopover.style.cssText=`
            max-height: 83px;
            max-width: 100%;
            line-height: 1.5;
            margin-top: 18px;
            padding: 10px;
            fony-size: 25px;
            -webkit-line-clamp: 3;
            -webkit-box-orient: vertical;
            overflow: hidden;
            text-overflow: ellipsis;`
         popover.appendChild(valuepopover)
         setTimeout(()=>{
        document.body.appendChild(popover);
      },2000)
      popover.addEventListener("click",() => {
        let iframe = document.getElementById("custom-chatbot-bubble-window");
        if(popover){
          popover.style.display= "none"
        }
        if (iframe) {
          if (iframe.style.display === "none") {
            setTimeout(() => {
              svgElement.style.display = "none";
              svgElementClose.style.display = "block";
              iframe.style.display = "block";
            }, 200);
          } else {
            setTimeout(() => {
              iframe.style.display = "none";
              svgElementClose.style.display = "none";
              svgElement.style.display = "block";
              if(imageToggle)
                image.src= imageToggle
            }, 200);
          }
        } 
        else {
          svgElement.style.display = "none";
          svgElementClose.style.display = "block";
          setTimeout(() => {
            iframe = document.createElement("iframe");
            iframe.allow = "fullscreen;microphone";
            iframe.title = "Custom chatbot bubble window";
            iframe.id = "custom-chatbot-bubble-window";
            iframe.src = `${baseUrl}/chatbot/${token}`;
            iframe.style.cssText = `
              border: none; 
              position: fixed; 
              bottom: 90px; 
              right: 16px; 
              width: 400px; 
              max-width: calc(1920px - 32px); 
              height: 75vh; 
              max-height: calc(100vh - 96px); 
              border-radius: 12px; 
              display: flex; 
              box-shadow: rgba(0, 0, 0, 0.2) 0px 2px 6px;
              z-index: 2147483647; 
              background-color: #F3F4F6;
              transition: all 0.2s ease-in-out;
              animation: move 0.3s ease-in-out;
            `;
            document.body.appendChild(iframe);
          }, 200);
        }
      });
      }   
      var button = document.createElement("div");
      button.id = "custom-chatbot-bubble-button";
      button.style.cssText = `
        position: fixed; 
        bottom: 16px; 
        right: 16px; 
        width: 60px; 
        height: 60px;
        border-radius: 9999px;
        cursor: pointer; 
        z-index: 2147483647; 
        transition: all 0.2s ease-in-out 0s; 
        transform: scale(1);
        animation: slideIn  0.2s ease-in-out forwards;
        overflow: hidden;
        display:flex;
        justify-content: center;
        justify-items: center;
        align-items: center;
      `;
      if(colorBg){
        button.style.background = colorBg
      }
      else {
      button.style.background = '#165eef';
      }
      button.addEventListener("mouseover", () => {
        button.style.transform = "scale(1.05)";
      });
      button.addEventListener("mouseout", () => {
        button.style.transform = "scale(1)";
      });
      const iconChatToggle = document.createElement("div");
      iconChatToggle.cssText=`
      display:flex;
      `
      var svgNS = "http://www.w3.org/2000/svg";
        var svgElement = document.createElementNS(svgNS, "svg");
        svgElement.style.cssText = `
          animation: rotate 0.2s ease-in-out;
        `
        svgElement.setAttribute("width", "32");
        svgElement.setAttribute("height", "30");
        svgElement.setAttribute("viewBox", "0 0 39 37");
        svgElement.innerHTML = `<defs><path id="conversations-visitor-open-icon-path-1:r0:" d="M31.4824242 24.6256121L31.4824242 0.501369697 0.476266667 0.501369697 0.476266667 24.6256121z"></path></defs><g fill="none" fill-rule="evenodd" stroke="none" stroke-width="1"><g transform="translate(-1432 -977) translate(1415.723 959.455)"><g transform="translate(17 17)"><g transform="translate(6.333 .075)"><path fill="#ffffff" d="M30.594 4.773c-.314-1.943-1.486-3.113-3.374-3.38C27.174 1.382 22.576.5 15.36.5c-7.214 0-11.812.882-11.843.889-1.477.21-2.507.967-3.042 2.192a83.103 83.103 0 019.312-.503c6.994 0 11.647.804 12.33.93 3.079.462 5.22 2.598 5.738 5.728.224 1.02.932 4.606.932 8.887 0 2.292-.206 4.395-.428 6.002 1.22-.516 1.988-1.55 2.23-3.044.008-.037.893-3.814.893-8.415 0-4.6-.885-8.377-.89-8.394"></path></g><g fill="#ffffff" transform="translate(0 5.832)"><path d="M31.354 4.473c-.314-1.944-1.487-3.114-3.374-3.382-.046-.01-4.644-.89-11.859-.89-7.214 0-11.813.88-11.843.888-1.903.27-3.075 1.44-3.384 3.363C.884 4.489 0 8.266 0 12.867c0 4.6.884 8.377.889 8.393.314 1.944 1.486 3.114 3.374 3.382.037.007 3.02.578 7.933.801l2.928 5.072a1.151 1.151 0 001.994 0l2.929-5.071c4.913-.224 7.893-.794 7.918-.8 1.902-.27 3.075-1.44 3.384-3.363.01-.037.893-3.814.893-8.414 0-4.601-.884-8.378-.888-8.394"></path></g></g></g></g>`;

        var svgClose = "http://www.w3.org/2000/svg";
        let svgElementClose = document.createElementNS(svgClose, "svg");
        svgElementClose.style.cssText= `
          animation: rotateClose 0.2s ease-in-out;
          display: none;
        `
        svgElementClose.setAttribute("width", "23");
        svgElementClose.setAttribute("height", "23");
        svgElementClose.setAttribute("viewBox", "0 0 19 18");
        svgElementClose.setAttribute("class", "conversations-visitor-close-icon");

        const gElement1 = document.createElementNS(svgClose, "g");
        gElement1.setAttribute("fill", "none");
        gElement1.setAttribute("fill-rule", "evenodd");
        gElement1.setAttribute("stroke", "none");
        gElement1.setAttribute("stroke-width", "1");

        const gElement2 = document.createElementNS(svgClose, "g");
        gElement2.setAttribute("fill", "#ffffff");
        gElement2.setAttribute("transform", "translate(-927 -991) translate(900.277 962)");

        const gElement3 = document.createElementNS(svgClose, "g");
        gElement3.setAttribute("transform", "translate(27 29)");

        const pathElement = document.createElementNS(svgClose, "path");
        pathElement.setAttribute("d", "M10.627 9.013l6.872 6.873.708.707-1.415 1.414-.707-.707-6.872-6.872L2.34 17.3l-.707.707L.22 16.593l.707-.707L7.8 9.013.946 2.161l-.707-.708L1.653.04l.707.707L9.213 7.6 16.066.746l.707-.707 1.414 1.414-.707.708-6.853 6.852z");

        gElement3.appendChild(pathElement);
        gElement2.appendChild(gElement3);
        gElement1.appendChild(gElement2);
        svgElementClose.appendChild(gElement1);

      const iconRobo = document.createElement('i');
      iconRobo.className = 'fa-solid fa-robot';
      iconRobo.style.cssText=`
      color: white;
      font-size: 20px;
      `;
      const iconRoboContainer = document.createElement('div');
      iconRoboContainer.style.cssText = `
        width: 50px;
        height: 50px;
        border-radius: 9999px;
        position: absolute;
        display: flex; 
        align-items: center; 
        justify-content: center; 
        z-index: 2147483640;
        top: -25px;
        right: 80px;
      `
      iconRoboContainer.style.backgroundColor = colorBg
      iconRoboContainer.appendChild(iconRobo)
      const image = document.createElement("img");
      image.style.cssText = `
        position: absolute;
        display: flex; 
        align-items: center; 
        justify-content: center; 
        width: 50px;
        height: 50px; 
        top: -25px;
        right: 80px;
        border-radius: 9999px;
        z-index: 2147483640;
        object-fit: cover;
      `;
      image.src = imageToggle
      if(popover){
        if(imageToggle){
          popover.appendChild(image)
        }
        else{
          popover.appendChild(iconRoboContainer)
        }
      }
      button.appendChild(svgElement);
      button.appendChild(svgElementClose);
      setTimeout(()=>{
        document.body.appendChild(button);
      },1500)
      setTimeout(()=>{
        button.style.animation =''
      },2000)

      button.addEventListener("click", () => {
        let iframe = document.getElementById("custom-chatbot-bubble-window");
        if(popover){
          popover.style.display= "none"
        }
        if (iframe) {
          if (iframe.style.display === "none") {
            iframe.style.animation = ""
            iframe.style.animation = "move 0.3s ease-in-out"
            setTimeout(() => {
              svgElement.style.display = "none";
              svgElementClose.style.display = "block";
              iframe.style.display = "block";
            }, 200);
          } else {
            iframe.style.animation = ""
            iframe.style.animation = "remove 0.3s ease-in-out"
            setTimeout(() => {
              iframe.style.display = "none";
              svgElementClose.style.display = "none";
              svgElement.style.display = "block";
              if(imageToggle)
                image.src= imageToggle
            }, 200);
          }
        } 
        else {
          svgElement.style.display = "none";
          svgElementClose.style.display = "block";
          setTimeout(() => {
            iframe = document.createElement("iframe");
            iframe.allow = "fullscreen;microphone";
            iframe.title = "Custom chatbot bubble window";
            iframe.id = "custom-chatbot-bubble-window";
            iframe.src = `${baseUrl}/chatbot/${token}`;
            iframe.style.cssText = `
              border: none; 
              position: fixed; 
              bottom: 90px; 
              right: 16px; 
              width: 400px; 
              max-width: calc(1920px - 32px); 
              height: 75vh; 
              max-height: calc(100vh - 96px); 
              border-radius: 12px; 
              display: flex; 
              box-shadow: rgba(0, 0, 0, 0.2) 0px 2px 6px;
              z-index: 2147483647; 
              background-color: #F3F4F6;
              transition: all 0.5s ease-in-out;
              animation: move 0.2s ease-in-out;
            `;
            document.body.appendChild(iframe);
          }, 200);
        }
      });
    } else {
      console.error(
        "customChatbotConfig is empty or token is not provided"
      );
    }
  }

  document.body.onload = embedChatbot;